#pragma once

#include <glad/glad.h>

#include <vector>
#include <string>

//Forward declaration of entity.
class Entity;

class Texture {
public:
    std::string name;
    std::vector<Entity*> usedBy;
    GLuint id = 0;
    void load(const char* file, bool storeOnTextureList);
    virtual void erase();
    void erase(Texture* texture) const;
    Texture(std::string& name, const char* filePath, bool storeOnTextureList);
    Texture() = default;
};

class MultiTexture : public Texture {
public:
    void erase() override;
    std::vector<Texture> multi;
    MultiTexture(const std::string& name, const char* pathContainingTextures, bool storeOnTextureList);
};