#include <types/entity/skybox.h>
#include <engine/engine.h>
#include <types/entity/camera.h>
void Skybox::pre_render() {
    Camera* camera;
    for (auto& e : engine->world->GetChildren())
        if (auto* c = dynamic_cast<Camera*>(e) )
            camera = c;
    position = camera->GetPos();
}

void Skybox::render() {
    glPushMatrix();
    glTranslatef(position.x ,position.y, position.z);
    glBindTexture(GL_TEXTURE_2D, getTexture()->id);
    glCullFace(GL_FRONT);
    glScalef(getScale(), getScale(), getScale());
    getGeometry()->draw();
    glCullFace(GL_BACK);
    glBindTexture(GL_TEXTURE_2D,0);
    glPopMatrix();
}

Skybox::Skybox() {
    name = "skybox";
    modelPath = engine->workingDir + "/assets/models/sphere_vlo.obj";
    texturePath = engine->workingDir + "/assets/textures/missing.png";
    setScale(engine->farPlane);
}